> ## Documentation Index > Fetch the complete documentation index at: https://docs.mapp.com/llms.txt > Use this file to discover all available pages before exploring further. # List all available dimensions and metrics > List all available dimensions and metrics ## OpenAPI ````json GET /query-objects { "openapi": "3.0.3", "info": { "title": "Analytics API", "description": "OpenAPI 3.0 Specification of Mapp Intelligence AnalyticsAPI \n\n In order to use these endpoints you must authorize by using a valid OAuth clientID configured in Mapp Intelligence Settings section.", "version": "1.0.0", "contact": { "name": "Technical Support Mapp Digital", "url": "https://mapp.com/tech-support/" } }, "servers": [ { "url": "https://api.mapp.com/api/analytics", "description": "Production" } ], "security": [ { "oauth_security_scheme": [ "mapp.intelligence-api" ] } ], "tags": [ { "name": "Analysis", "description": "Submit analysis and get data" }, { "name": "Available Objects", "description": "Get information about available objects you can use to build Analysis" } ], "paths": { "/query-objects": { "get": { "tags": [ "Available Objects" ], "summary": "List all available dimensions and metrics", "description": "List all available dimensions and metrics", "externalDocs": { "url": "https://documentation.mapp.com" }, "parameters": [ { "name": "language", "in": "query", "description": "Optional standard ISO-639-1 language code for translation (when applicable).\n\nOnly \"de\" and \"en\" supported for the moment. \n\nDefault is \"en\"", "required": "false", "schema": { "type": "string" } } ], "responses": { "200": { "description": "OK", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/QueryObjects" }, "examples": { "Query Objects": { "$ref": "#/components/examples/queryObjectExample" } } } } }, "403": { "$ref": "#/components/responses/Forbidden" } } } } }, "components": { "schemas": { "QueryObjects": { "title": "QueryObjects", "type": "object", "properties": { "metrics": { "type": "array", "description": "List of available metrics", "items": { "$ref": "#/components/schemas/Metric" } }, "dimensions": { "type": "array", "description": "List of available dimensions", "items": { "$ref": "#/components/schemas/Dimension" } } }, "required": [ "metrics", "dimensions" ] }, "Metric": { "title": "Metric", "type": "object", "description": "Description of a metric", "properties": { "name": { "type": "string", "description": "API name of the metric" }, "dataType": { "$ref": "#/components/schemas/DataTypeEnum" }, "title": { "type": "string", "description": "Human readable name of the metric. Localized" }, "elementType": { "$ref": "#/components/schemas/ElementTypeEnum" }, "metricDisplayType": { "$ref": "#/components/schemas/DisplayTypeEnum" }, "context": { "$ref": "#/components/schemas/ContextEnum" }, "sortable": { "type": "boolean", "description": "Indicates if object can be sorted." } }, "required": [ "name", "dataType", "title", "elementType", "metricDisplayType" ] }, "Dimension": { "title": "Dimension", "type": "object", "description": "Description of a Dimension element", "properties": { "name": { "type": "string", "description": "API name of the dimension" }, "dataType": { "$ref": "#/components/schemas/DataTypeEnum" }, "title": { "type": "string", "description": "Human readable name of the metric. Localized" }, "elementType": { "$ref": "#/components/schemas/ElementTypeEnum" }, "context": { "$ref": "#/components/schemas/ContextEnum" }, "mapping": { "type": "object", "description": "Optional list of Mapping values", "additionalProperties": { "type": "string" } }, "timeFormatPattern": { "description": "Standard datetime pattern. Indicates that current STRING represents a Date", "type": "string" }, "sortable": { "type": "boolean", "description": "Indicates if object can be sorted." } }, "required": [ "name", "dataType", "title", "elementType" ] }, "Problem": { "type": "object", "properties": { "status": { "type": "integer", "description": "HTTP Status Code" }, "statusCode": { "type": "string", "description": "Specific Mapp Error Code" }, "title": { "type": "string", "description": "Short description of the problem" }, "detail": { "type": "string", "description": "Detailed informations about the problem" }, "errors": { "type": "array", "items": { "$ref": "#/components/schemas/Error" } }, "warnings": { "type": "array", "items": { "$ref": "#/components/schemas/Warning" } } } }, "DataTypeEnum": { "type": "string", "description": "Type of data", "enum": [ "STRING", "NUMBER", "GENERIC" ] }, "ElementTypeEnum": { "type": "string", "description": "Type of element", "enum": [ "CAMPAIGNS_ATTRIBUTION", "CUSTOM_CATEGORY", "CUSTOM_FORMULA", "CUSTOM_METRIC", "CUSTOM_PARAMETER", "CUSTOM_PROCESS", "CUSTOM_SOURCE", "CUSTOM_VISITOR_GROUPS_TRAFFIC", "CUSTOM_WEBSITE_GOALS", "DEFAULT_DIMENSION", "DEFAULT_METRIC", "PREDEFINED_FORMULA", "PREDEFINED_METRIC" ] }, "DisplayTypeEnum": { "type": "string", "description": "Indicate how the data should be displayed", "enum": [ "NORMAL", "TIME", "CURRENCY", "DISTRIBUTION", "COMPARE" ] }, "ContextEnum": { "type": "string", "description": "Context to evaluate the metric/dimension. If context property is not given or empty the default context of the object will be used. The default context can be identified from the context property in the response list of /query-objects.", "enum": [ "VISITOR", "SESSION", "PAGE", "ACTION", "ATOMIC", "NONE" ] }, "Error": { "type": "object", "properties": { "name": { "type": "string", "description": "Each error has specific properties described in following table:\n\n| Error| Description | Relevant parameters |\n| ---------------- | ------------| -----------------------------------|\n| UnmappedName | At least one object name cannot be found. | List of objects not found in _names_ array. |\n| PivotIncompatibleMetric | Metric not usable in Pivot detected.| List of incompatible Metrics in _names_ array. |\n| PivotIncompatibleDimension |Dimension not usable in Pivot detected. | List of incompatible Dimensions in _names_ array. |\n| AnalysisLogicalCubeMismatch | All Dimensions and Metrics are not compatible. | List of incompatible objects in _names_ array. |\n| InvalidSortingCriteria | Sorting is applied on a non-sortable object.| List of invalid sorted objects in _names_ array. |\n| TimeFilterMissing | Each query must have a minimum of one Time Filter.| N/A |\n| InvalidSegmentNoneContainer | A segment container has context set to NONE but either its connector is not set to AND or its inOrNotIn property is not set to IN.| N/A |", "enum": [ "UnmappedName", "PivotIncompatibleMetric", "PivotIncompatibleDimension", "AnalysisLogicalCubeMismatch", "InvalidSortingCriteria", "TimeFilterMissing", "InvalidSegmentNoneContainer" ] }, "parameters": { "type": "object", "properties": { "arrangeTypes": { "type": "array", "description": "List of internal object names (dimension, metrics, filter, ...) that corresponds to the error.", "items": { "type": "string" } }, "aliases": { "type": "array", "description": "List of columns aliases that corresponds to the error. See Result Header alias property.", "items": { "type": "string" } }, "names": { "type": "array", "description": "List of object names (dimension, metrics, filter, ...) that corresponds to the error.", "items": { "type": "string" } } } } } }, "Warning": { "type": "object", "properties": { "name": { "type": "string", "description": "Each warnings has specific properties described in following table:\n\n| Warning| Description | Relevant parameters |\n| ---------------- | ------------| -----------------------------------|\n| FilterLogicalCubeMismatch | At least one filter is ignored due to incompatibily with Dimensions and Metrics used. | List of incomptible filter objects in _names_ array. |\n| InvalidMetricContext | Metric used in an invalid context. | List of metric with invalid context in _aliases_ array. |\n| SortingEnforced | Sorting criteria has been added automatically | List of objects that were sorted automatically in _aliases_ array. |\n| NoSortingDefined | Sorting criteria is required for some dimensions. | List of dimensions requiring a sorting in _names_ array. |\n| SortingLimitExceeded | 3 sorting criteria are allowed. All additional sorting criteria have been omitted.| List of columns ignored for sorting in _aliases_ array. |\n| SortingRemoved | A requested sorting criteria has been removed | List of objects that were removed automatically in _aliases_ array. |\n| TodayRemoved | Today date has been removed from calculation time range because the selected datasource does not contain it. | daysInDataSource, todayDate|", "enum": [ "FilterLogicalCubeMismatch", "InvalidMetricContext", "SortingEnforced", "NoSortingDefined", "SortingLimitExceeded", "SortingRemoved", "TodayRemoved" ] }, "parameters": { "type": "object", "properties": { "arrangeTypes": { "type": "array", "description": "List of internal object names (dimension, metrics, filter, ...) that corresponds to the warning.", "items": { "type": "string" } }, "aliases": { "type": "array", "description": "List of columns aliases that corresponds to the error. See Result Header alias property.", "items": { "type": "string" } }, "names": { "type": "array", "description": "List of object names (dimension, metrics, filter, ...) that corresponds to the warning.", "items": { "type": "string" } }, "daysInDataSource": { "type": "string", "description": "Number of days in the datasource which is beeing cut" }, "todayDate": { "type": "string", "description": "Date of the day being cut" } } } } } }, "examples": { "queryObjectExample": { "value": { "metrics": [ { "name": "alexaRanking", "context": "NONE", "dataType": "NUMBER", "sortable": "true", "title": "Alexa Ranking", "elementType": "DEFAULT_METRIC", "metricDisplayType": "NORMAL" }, { "name": "attribution_1_order_qty", "context": "ACTION", "dataType": "NUMBER", "sortable": "true", "title": "Qty Orders (Attribution last session, external), Order", "elementType": "CAMPAIGNS_ATTRIBUTION", "metricDisplayType": "NORMAL" }, { "name": "custom_metric_1000853", "context": "SESSION", "dataType": "NUMBER", "sortable": "true", "title": "Android Users (Segment)", "elementType": "CUSTOM_METRIC", "metricDisplayType": "NORMAL" }, { "name": "media_chapter_1", "context": "ATOMIC", "dataType": "NUMBER", "sortable": "true", "title": "Media Chapter 1", "elementType": "DEFAULT_METRIC", "metricDisplayType": "NORMAL" }, { "name": "page_category_number_13_sum", "context": "NONE", "dataType": "NUMBER", "sortable": "true", "title": "Social Metrics", "elementType": "CUSTOM_CATEGORY", "metricDisplayType": "NORMAL" }, { "name": "products_viewed_qty", "context": "ATOMIC", "dataType": "NUMBER", "sortable": "true", "title": "Qty Product Views", "elementType": "DEFAULT_METRIC", "metricDisplayType": "NORMAL" } ], "dimensions": [ { "name": "attribution_1", "context": "NONE", "dataType": "NUMBER", "sortable": "true", "title": "Attribution (last session, external) of Order", "elementType": "CAMPAIGNS_ATTRIBUTION", "mapping": { "": "No Filter", "*": "All" } }, { "name": "attribution_2", "context": "NONE", "dataType": "NUMBER", "sortable": "true", "title": "Attribution (multiple, external) of Order", "elementType": "CAMPAIGNS_ATTRIBUTION", "mapping": { "": "No Filter", "*": "All" } }, { "name": "device_deviceClass", "context": "SESSION", "dataType": "NUMBER", "sortable": "true", "title": "Device Class", "elementType": "DEFAULT_DIMENSION", "mapping": { "0": "PC / Laptop", "1": "Smartphone", "2": "Tablet", "3": "TV", "4": "Console", "5": "Smartwatch", "6": "E-Reader", "7": "Mediahub", "8": "other", "1000": "unknown", "": "No filter" } }, { "name": "device_model", "context": "SESSION", "dataType": "STRING", "sortable": "false", "title": "Device Model", "elementType": "DEFAULT_DIMENSION" }, { "name": "user_country", "context": "SESSION", "dataType": "STRING", "sortable": "false", "title": "URM - Country", "elementType": "DEFAULT_DIMENSION" }, { "name": "user_gender", "context": "SESSION", "dataType": "NUMBER", "sortable": "true", "title": "URM - Gender", "elementType": "DEFAULT_DIMENSION", "mapping": { "0": "unknown", "1": "Man", "2": "Woman", "": "No filter" } }, { "name": "user_id", "context": "SESSION", "dataType": "STRING", "sortable": "false", "title": "URM - Visitor Id", "elementType": "DEFAULT_DIMENSION" }, { "name": "user_lastVisit", "context": "SESSION", "dataType": "NUMBER", "sortable": "true", "title": "URM - Last Visit", "elementType": "DEFAULT_DIMENSION", "mapping": { "0": "No", "1": "Yes", "": "No filter" } }, { "name": "user_lastVisitWithPurchase", "context": "SESSION", "dataType": "NUMBER", "sortable": "true", "title": "URM - Last Visit with a Purchase", "elementType": "DEFAULT_DIMENSION", "mapping": { "0": "No", "1": "Yes", "": "No filter" } }, { "name": "user_macroStatus", "context": "SESSION", "dataType": "NUMBER", "sortable": "true", "title": "URM - Customer Macro Status", "elementType": "DEFAULT_DIMENSION", "mapping": { "0": "unknown", "1": "Offsite", "2": "Onsite", "3": "Product view", "4": "Abandoned basket", "5": "Registration", "6": "New Customer", "7": "Returning buyer", "": "No filter" } }, { "name": "visitors_newVsReturning", "context": "SESSION", "dataType": "NUMBER", "sortable": "true", "title": "New vs. Returning", "elementType": "DEFAULT_DIMENSION", "mapping": { "0": "Returning", "1": "New", "2": "Unknown", "": "No filter" } } ] } } }, "responses": { "Forbidden": { "description": "No permission to execute operation", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/Problem" }, "examples": { "AnalysisNotFound": { "summary": "Invalid Token", "value": { "title": "Invalid Token", "status": "403", "detail": "Token not valid", "statusCode": "INVALID_TOKEN" } } } } } } }, "securitySchemes": { "oauth_security_scheme": { "type": "oauth2", "flows": { "clientCredentials": { "tokenUrl": "https://auth.mapp.com/oauth2/token" } } } } } } ````